require "import"
import "com.androlua.*"
local Http = luajava.bindClass("com.androlua.Http")
local EditText = luajava.bindClass("android.widget.EditText")

-- Função para exibir o diálogo de entrada do código
function showCodeDialog()
    local dlg = LuaDialog()
    local editText = EditText()
    editText.setHint("Digite o código")
    dlg.setView(editText)
    dlg.setTitle("Digite o código de rastreamento")
    dlg.setPositiveButton("OK", function(dialog, which)
        local code = editText.getText().toString()
        
        if code ~= "" and #code > 0 then
            local url = "http://androidparacegos.com.br:5001/rastrear/" .. code
            Http.get(url, function(status, data)
                if status == 200 then
                    -- Decodifica o JSON retornado em uma tabela Lua
                    local json = require("cjson")
                    local decoded_data = json.decode(data)
                    
                    -- Imprime os resultados
                    print("Código: " .. decoded_data.codigo)
                    print("Host: " .. decoded_data.host)
                    print("Quantidade: " .. decoded_data.quantidade)
                    print("Serviço: " .. decoded_data.servico)
                    
                    print("Eventos:")
                    for i, evento in ipairs(decoded_data.eventos) do
                        print("Evento " .. i)
                        print("Data: " .. evento.data)
                        print("Hora: " .. evento.hora)
                        print("Local: " .. evento.local)
                        print("Status: " .. evento.status)
                        if evento.subStatus and #evento.subStatus > 0 then
                            print("Substatus:")
                            for j, subStatus in ipairs(evento.subStatus) do
                                print("  " .. subStatus)
                            end
                        end
                    end
                else
                    print("Erro ao fazer a solicitação HTTP. Status: " .. status)
                end
            end)
        else
            print("Por favor, digite um código válido.")
        end
    end)
    dlg.show()
end

-- Exibe o diálogo de entrada do código
showCodeDialog()
